



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unique Letter String LT828</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unique Letter String LT828</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 02:46:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>A character is unique in string <code>S</code> if it occurs exactly once in it.</p>
<p>For example, in string <code>S = "LETTER"</code>, the only unique characters are <code>"L"</code> and <code>"R"</code>.</p>
<p>Let's define <code>UNIQ(S)</code> as the number of unique characters in string <code>S</code>.</p>
<p>For example, <code>UNIQ("LETTER") =&nbsp; 2</code>.</p>
<p>Given a string <code>S</code> with only uppercases, calculate the sum of <code>UNIQ(substring)</code> over all non-empty substrings of <code>S</code>.</p>
<p>If there are two or more equal substrings at different positions in <code>S</code>, we consider them different.</p>
<p>Since the answer can be very large, return&nbsp;the answer&nbsp;modulo&nbsp;<code>10 ^ 9 + 7</code>.</p>
<p>Idea 1. Dynamic programming, it's a bit tricky, need to store last two indexes for each char appears in the array, assume dp[i] is the number of unique characters ending at s[i]</p>
<p>dp[i] = dp[i-1] + (i - last[s[i]]) - (last[s[i]] - 2ndLast[s[i]]))</p>
<p>ABCBDAB</p>
<p>i = 0, {A}, dp[0] = 1</p>
<p>i = 1, {AB, B}, dp[1] = 3</p>
<p>i = 2, {ABC, BC, C}, dp[2] = 6</p>
<p>i = 3, {ABCB, BCB, CB, B}, dp[3] = 6 = dp[2] + (3 - 1) -(1 - (-1)) = 6</p>
<p>Time complexity: O(n)</p>
<p>Space complexity: O(n) or O(26)</p>
<div>
<pre class="prettyprint linenums"> class Solution {<br />
     public int uniqueLetterString(String S) {<br />
         int[] last = new int[26];<br />
         int[] secondLast = new int[26];<br />
         Arrays.fill(last, -1);<br />
         Arrays.fill(secondLast, -1);

         int dp = 0;<br />
         int result = 0;<br />
         for(int i = 0; i &lt; S.length(); ++i) {<br />
             int a = S.charAt(i) - 'A';<br />
             dp = dp + (i -last[a]) - (last[a] - secondLast[a]);<br />
             result += dp;<br />
             secondLast[a] = last[a];<br />
             last[a] = i;<br />
         }

         return result;<br />
     }<br />
 }</pre>
</div>
<p>Idea 2. Similar to&nbsp;<a href="https://www.cnblogs.com/taste-it-own-it-love-it/p/10777561.html" rel="external nofollow noreferrer">Sum of Subsequence Widths LT891</a>, instead of getting all the unique characters for substring ending at index i, focus on the contribution of each character, count how many times it appears as a unique character in a substring, then sum it up for each char in the string and get the result.</p>
<p>ABCBDAB, for the middle 'B', on the left, substring ending at 'B': B, CB</p>
<p>　　　　　　　　　　　　　　on the right, substring starting at 'B': B, BD, BDA</p>
<p>'B' can appears 2 * 3 = 6 substring, B, BD, BDA, CB, CBD, CBDA,</p>
<p>It can observed that the count is depend on the nearest same char on the left and on the right,</p>
<p>　　(i - prev) * (next - i)</p>
<p>Time complexity: O(n)</p>
<p>Space complexity: O(n)</p>
<p>Using hashmap to store the index of char in the string</p>
<div>
<pre class="prettyprint linenums"> class Solution {<br />
     public int uniqueLetterString(String S) {<br />
         Map&lt;Character, List&lt;Integer&gt;&gt; charIndex = new HashMap&lt;&gt;();<br />
         int n = S.length();<br />
         for(int i = 0; i &lt; n; ++i) {<br />
             char c = S.charAt(i);<br />
             if(!charIndex.containsKey(c)) {<br />
                 charIndex.put(c, new ArrayList&lt;Integer&gt;());<br />
             }<br />
             charIndex.get(c).add(i);<br />
         }

         long result = 0;<br />
         long mod = (long)1e9+7;

         for(List&lt;Integer&gt; positions: charIndex.values()) {

             for(int i = 0; i &lt; positions.size(); ++i) {<br />
                 int prev = i &gt; 0? positions.get(i-1) : -1;<br />
                 int next = i &lt; positions.size()-1? positions.get(i+1) : n;

                 int curr = positions.get(i);<br />
                 result = (result + (curr-prev) * (next - curr))%mod;<br />
             }<br />
         }

         return (int)result;<br />
     }<br />
 }</pre>
</div>
<p>Idea 2.b store index at array prev[], next[] by scanning the string from left to right, and right to left</p>
<p>Time complexity: O(n)</p>
<p>Space complexity: O(n)</p>
<div>
<pre class="prettyprint linenums"> class Solution {<br />
     public int uniqueLetterString(String S) {<br />
         int n = S.length();<br />
         int[] charIndex = new int[26];<br />
         Arrays.fill(charIndex, -1);

         int[] prev = new int[n];<br />
         for(int i = 0; i &lt; n; ++i) {<br />
             int a = S.charAt(i) - 'A';<br />
             prev[i] = charIndex[a];<br />
             charIndex[a] = i;<br />
         }

         Arrays.fill(charIndex, n);<br />
         int[] next = new int[n];<br />
         for(int i = n-1; i &gt;= 0;--i) {<br />
             int a = S.charAt(i) - 'A';<br />
             next[i] = charIndex[a];<br />
             charIndex[a] = i;<br />
         }

         int result = 0;<br />
         int mod = (int)(1e9) + 7;

         for(int i = 0; i &lt; n; ++i) {<br />
             result = (result + (i - prev[i])*(next[i] - i))%mod;<br />
         }

         return result;<br />
     }<br />
 }</pre>
</div>
<p><strong>Example 1:</strong></p>
<pre class="prettyprint linenums"><strong>Input: </strong>"ABC"<br />
<strong>Output: </strong>10<br />
<strong>Explanation: </strong>All possible substrings are: "A","B","C","AB","BC" and "ABC".<br />
Evey substring is composed with only unique letters.<br />
Sum of lengths of all substring is 1 + 1 + 1 + 2 + 2 + 3 = 10</pre>
<p><strong>Example 2:</strong></p>
<pre class="prettyprint linenums"><strong>Input: </strong>"ABA"<br />
<strong>Output: </strong>8<br />
<strong>Explanation: </strong>The same as example 1, except uni("ABA") = 1.
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxlde0q.html">python 面向对象&lpar;类&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlon3q.html">学习Coding-iOS开源项目日志（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24w5o8.html">&lbrack;异常&rsqb; Download interrupted&colon; Connection to https&colon;&sol;&sol;dl-ssl&period;google&period;com refused   安卓SDK下载被拒 3步解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wm2plq.html">C&plus;&plus;二叉树的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd04zr8.html">Python15-day1课后作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3mnx9.html">MVC学习系列&mdash;&mdash;参考</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0z019.html">Android扫描二维码 实现 登录网页</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mroyo8.html">linux sendEmail工具的安装使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzo4n08.html">音频处理EQ的基本概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkvkxj8.html">安卓9&period;0系统机器&lpar;亲测有效&rpar;激活Xposed框架的步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/950owvz8.html">properJavaRDP  跑通本地远程桌面</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6opn8.html">简述一下MVC和MVVM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gelre08.html">JavaFile、递归、字节流、字符流整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9607pv49.html">SpringCloud第一弹&lpar;入门&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwxp009.html">WinForm版图像编辑小程序（实现图像拖动、缩放、旋转、抠图）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjgdgq.html">Properties （25）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rzyzn9.html">Java中Properties集合总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw6y2v9.html">ionic之angular1&period;X缓存问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjmykr8.html">大数据入门第二十二天&mdash;&mdash;spark（二）RDD算子（2）与spark其它特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pypdn8.html">C&plus;&plus;11 function</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv211nj9.html">【HDFS API编程】副本系数深度剖析</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g0g6mq.html">设计CUBE by kylin</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g03v6q.html">c&plus;&plus;堆和栈（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25j02wq.html">【EFM32】EFM32芯片解锁、加锁操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvjyg38.html">求&dollar;N&Hat;N&dollar;的首位数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4yw3x9.html">springCloud面试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g0d46q.html">Linux内核d&lowbar;path函数应用的经验总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlljwn6q.html">机器学习--Xgboost调参</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5g617q.html">pytest学习--快速入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvjg328.html">pyparsing自定义解析规则</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
